;;;; IRC packages config

(require 'erc)
(setq erc-default-coding-system 'utf-8
      erc-autojoin-channels-alist
      '(("freenode" . ("#emacs" "#lilypond" "#velvetandlace" "#opensourcemusicians"
                       "##classical" "##guitar" "##deutsch" "##hindi")))
      erc-password "trololo_trololo"
      erc-fill-mode nil
      erc-generate-log-file-name-function 'erc-generate-log-file-name-network
      erc-log-channels-directory "~/.emacs.d/erc/logs/"
      erc-log-mode t
      erc-log-write-after-insert t
      erc-modules '(autojoin completion list log menu ring stamp ercn
                             netsplit button match track readonly networks noncommands
                             irccontrols move-to-prompt)
      erc-nick '("contrapunctus" "HisaoNakai" "[Batou]" "[Togusa]" "[2501]")
      erc-stamp-mode t
      erc-timestamp-format-left "[%Y %m %e %T %N]
"
      erc-timestamp-format-right nil
      erc-join-buffer 'bury)

(global-unset-key (kbd "C-x e"))

(global-set-key (kbd "C-x e r") 'erc-server-reconnect)

(require 'rcirc)
(setq
 rcirc-log-flag t
 rcirc-time-format "%Y %m %e %T "
 rcirc-fill-column 80
 rcirc-server-alist '(("irc.freenode.net"
                       :channels ("#emacs" "#lilypond" "#velvetandlace" "#opensourcemusicians"
                                  "##classical" "##guitar" "##deutsch" "##hindi")
                       :password "trololo_trololo"))
 rcirc-default-nick "contrapunctus"
 ;; rcirc-coding-system-alist '(("" . 'utf-8))
 )


